diff a/src/hotspot/share/code/dependencies.cpp b/src/hotspot/share/code/dependencies.cpp
--- a/src/hotspot/share/code/dependencies.cpp
+++ b/src/hotspot/share/code/dependencies.cpp
@@ -833,13 +833,17 @@
 
     st->cr();
   }
   if (witness != nullptr) {
     bool put_star = !Dependencies::is_concrete_klass(witness);
-    st->print_cr("  witness = %s%s",
-                  (put_star? "*": ""),
-                  witness->external_name());
+    st->print("  witness = %s%s",
+              (put_star ? "*": ""),
+              witness->external_name());
+    if (witness->is_instance_klass()) {
+      st->print(" (%s)", InstanceKlass::cast(witness)->init_state_name());
+    }
+    st->cr();
   }
 }
 
 void Dependencies::DepStream::log_dependency(Klass* witness) {
   if (_deps == nullptr && xtty == nullptr)  return;  // fast cutout for runtime
